#include "vbcompat.bi"

type TypUeberschrift
  as string text         ' Textinhalt der Ueberschrift
  as ushort first, last  ' erstes bzw. letztes Unterelement
  as ushort next, parent ' naechstes Element derselben Ebene, Elternelement
  as ushort ebene, seite ' Ordnungsebene der Ueberschrift, Seite auf der sie steht
  as ushort nr           ' Ordnungsnummer innerhalb der Ebene
end type
type TypWort
  as ushort x, y, link
  as ubyte attribut
  as string text
end type
type TypLink
  as ushort x, x2, y, url
end type

declare sub add(byval text as string)
declare sub addzeile(byref newline as ubyte)
declare sub inhalt(byval nr as ubyte = 0)
declare function nummer(byval ueberschrift as TypUeberschrift) as string
declare sub schreibeSeite(byref seite as ubyte)
declare function ueberschrift2seite(byval nr as ubyte, byval nr2 as ubyte = 0) as ubyte

const as ubyte _fett = 16, _unterstrichen = 32
const as ushort _version = 201
dim shared as ushort _subversion
_subversion = dateserial(2008, 08, 28)

dim as string zeile, temp
dim shared as string wortliste(40), neutext
dim shared as TypWort wort(255, 500)
dim shared as ubyte wortzahl(255), zeilenzahl(255), laenge=0, attribut(40), headline = 1
dim shared as ubyte setFett=0, setUnterstrichen=0, setZentriert=0, setFarbe=15, AnzahlLinks
dim shared as ushort tabulator(40), url(40), setVersion, setUrl
dim shared as ushort AnzahlSeiten = 0, AnzahlUeberschriften = 0, AnzahlWoerter = 0, AnzahlZeilen = 0
dim as ushort ebene, nr, parent, i
dim shared as TypUeberschrift ueber(1 to 255)
dim shared as TypLink link(50)
dim shared as ubyte MaxLang(255), MaxEbene  ' wird fuer das Inhaltsverzeichnis benoetigt
dim as integer mx, my, mb
dim as ubyte history(255), AnzahlHistory, WARNUNG = 0, aktSubindex = 0, merke, haupt = 0

' veraenderbare Definitionen
dim shared as ubyte setHead0Underline = 1, setHead0Bold = 0, setHead0Center = 0 ' Hauptueberschrift
dim shared as ubyte setHead1Underline = 1, setHead1Bold = 0, setHead1Center = 0 ' sonstige Ueberschrift
dim shared as ubyte setHeadColor = 15, setColor = 15, setMenuColor = 7          ' Farbeinstellungen
dim shared as ubyte setLinkColor = 14, setLinkUnderline = 1                     ' Linkdarstellung
dim shared as ubyte setIndexDepth = 255, setSubIndex = 0                        ' Darstellung des Index
dim shared as ubyte setBackground = 0

' Argumente
dim shared as byte OPT_hilfe = 0, OPT_version = 0, OPT_index = 0, OPT_text = 0, OPT_format = 0
dim shared as string OPT_datei
OPT_datei = ""

' Optionen lesen und speichern
i = 1
if fileexists(*__FB_ARGV__[1]) then
  OPT_datei = *__FB_ARGV__[1]
  i += 1
end if
do while i < __FB_ARGC__
  select case *__FB_ARGV__[i]
    case "-h", "-help"    : OPT_hilfe = -1
    case "-v", "-version" : OPT_version = -1
    case "-i", "-index"   : OPT_index = -1
    case "-t", "-text"    : OPT_text = -1
    case "-f", "-format"  : OPT_format = -1
  end select
  i += 1
loop

if OPT_hilfe then
  print "ReadMe-Reader Version " & format(_version/100, "##.##") & " vom " & format(_subversion, "dd.mm.yy")
  print "Aufruf: reader2 [Datei] [Optionen]"
  print "Das Programm unterstuetzt (noch?) keine kombinierten Optionen!"
  print "ReadMe-Reader steht unter der GPL, Version 3."
  print "Rufen Sie 'reader reader.readme' auf, um mehr zu erfahren."
  print
  print "  -h, --help      diesen Hilfetext anzeigen"
  print "  -v, --version   Programmversion ausgeben"
  print "  -i, --index     Inhaltsverzeichnis (Standardausgabe)"
  print "  -t, --text      unformatierte Ausgabe (Standardausgabe)"
  print "  -f, --format    zusaetzlich formatierte Ausgabe (wird"
  print "                  nur zusammen mit -i oder -t benoetigt)"
  print
  end
end if
if OPT_version then
  print "ReadMe-Reader Version " & format(_version/100, "##.##") & " vom " & format(_subversion, "dd.mm.yy")
  print "compiliert am " & mid(__DATE__, 4, 2) & "." & left(__DATE__, 2) & ".";
  print right(__DATE__, 4) & ", " & __TIME__ & " Uhr"
  print
  end
end if

if OPT_datei <> "" then
  ' Datei in der Kommandozeile uebergeben
  open OPT_datei for input as #1
else
    dim dateien(25) as string, AnzahlDateien as ubyte
    dateien(0) = dir("*.readme")
    if dateien(0) = "" then
      print "Es wurden keine Dateien gefunden!"
      sleep
      end
    end if
    for AnzahlDateien = 1 to 25
      dateien(AnzahlDateien) = dir
      if dateien(AnzahlDateien) = "" then exit for
    next
    if AnzahlDateien > 1 then
      print " Waehlen Sie die gewuenschte Datei aus, indem Sie den Buchstaben eintippen:"
      print
      for i as ubyte = 0 to AnzahlDateien-1
        open dateien(i) for input as #1
        line input #1, temp
        if left(temp, 2) = "#!" then line input #1, temp
        close #1
        print " " & chr(65+i) & ") " & left(temp, 75)
      next
      do
        temp = ucase(input(1))
      loop until asc(temp) > 64 and asc(temp) < 65 + AnzahlDateien
      open dateien(asc(temp) - 65) for input as #1
    else
      open dateien(0) for input as #1
    end if
end if
AnzahlSeiten = 1
do while not eof(1)
  line input #1, zeile
  zeile = trim(zeile)
  if zeile = "[page]" then             ' neue Seite anlegen
    ' Versionsueberpruefung
    if AnzahlSeiten = 1 and setVersion > _version then WARNUNG = 1
    addZeile(1)
    AnzahlSeiten += 1
    AnzahlZeilen = 0
    AnzahlWoerter = 0
    laenge = 0
    continue do
  end if
  '************************************
  ' Setup-Informationen (vor Seite 1)
  if AnzahlSeiten = 1 then
    dim as string z = trim(lcase(zeile))
    if z = "setheadline0 not underline" then setHead0Underline = 0
    if z = "setheadline0 bold" then setHead0Bold = 1
    if z = "setheadline0 center" then setHead0Center = 1
    if z = "setheadline1 not underline" then setHead1Underline = 0
    if z = "setheadline1 bold" then setHead1Bold = 1
    if z = "setheadline1 center" then setHead1Center = 1
    if z = "setheadline not underline" then setHead0Underline = 0 : setHead1Underline = 0
    if z = "setheadline bold" then setHead0Bold = 1 : setHead1Bold = 1
    if z = "setheadline center" then setHead0Center = 1 : setHead1Center = 1
    if left(z, 17) = "setheadlinecolor " then setHeadColor = val(mid(z, 18)) mod 16
    if left(z, 14) = "setbackground " then setBackground = val(mid(z, 15)) mod 16
    if left(z, 13) = "settextcolor " then setColor = val(mid(z, 14)) mod 16 : setFarbe = setColor
    if left(z, 13) = "setlinkcolor " then setLinkColor = val(mid(z, 14)) mod 16
    if left(z, 13) = "setmenucolor " then setMenuColor = val(mid(z, 14)) mod 16
    if z = "setlink underline" then setLinkUnderline = 1
    if z = "setsubindex on" then setSubIndex = 1
    if left(z, 14) = "setindexdepth " then setIndexDepth = val(mid(z, 15))
    if left(z, 14) = "readerversion " then setVersion = val(mid(z, 15))
    continue do
  end if
  '************************************
  ' Erstellung des Ueberschriftenbaumes
  if left(zeile, 3) = "[*]" then       ' neue Ueberschrift
    if ebene = 0 then
      haupt += 1
      if setSubIndex = 1 then AnzahlSeiten += 1
    end if
    AnzahlUeberschriften += 1
    ueber(AnzahlUeberschriften).parent = parent
    temp = trim(mid(zeile, 4))
    if len(temp) > 63 then temp = left(temp, 60) & "..."
    ueber(AnzahlUeberschriften).text = temp
    if setIndexDepth >= ebene and len(temp) > MaxLang(0) then MaxLang(0) = len(temp)
    if len(temp) > MaxLang(haupt) then MaxLang(haupt) = len(temp)
    ueber(AnzahlUeberschriften).seite = AnzahlSeiten
    ueber(AnzahlUeberschriften).ebene = ebene
    ueber(AnzahlUeberschriften).next = AnzahlUeberschriften + 1
    nr += 1
    ueber(AnzahlUeberschriften).nr = nr
    if wortzahl(AnzahlSeiten) > 0 and headline = 0 then add "[newline] [newline] [newline]"
    if ebene = 0 then
      if setHead0Center = 1 then setZentriert += 1
      if setHead0Underline = 1 then setUnterstrichen += 1
      if setHead0Bold = 1 then setFett += 1
    else
      if setHead1Center = 1 then setZentriert += 1
      if setHead1Underline = 1 then setUnterstrichen += 1
      if setHead1Bold = 1 then setFett += 1
    end if
    dim as ubyte merke = setFarbe
    setFarbe = setHeadColor
    add nummer(ueber(AnzahlUeberschriften)) & ") " & ueber(AnzahlUeberschriften).text
    setFarbe = merke
    add "[newline] [newline]"
    if ebene = 0 then
      if setHead0Center = 1 then setZentriert -= 1
      if setHead0Underline = 1 then setUnterstrichen -= 1
      if setHead0Bold = 1 then setFett -= 1
    else
      if setHead1Center = 1 then setZentriert -= 1
      if setHead1Underline = 1 then setUnterstrichen -= 1
      if setHead1Bold = 1 then setFett -= 1
    end if
    headline = 1
    continue do
  end if
  if zeile = "[>]" then                ' Ueberschrift-Unterebene betreten
    ' Fehler abfangen
    if AnzahlUeberschriften = 0 then continue do
    if ueber(AnzahlUeberschriften-1).ebene < ebene then continue do
    ' ansonsten eine Ebene runter
    nr = 0
    parent = AnzahlUeberschriften
    ueber(parent).first = AnzahlUeberschriften + 1
    ebene += 1
    if ebene > MaxEbene then MaxEbene = ebene
    continue do
  end if
  if zeile = "[<]" then                ' Ueberschrift-Unterebene verlassen
    ' Fehler abfangen
    if ebene = 0 then continue do
    ' ansonsten eine Ebene runter
    nr = ueber(parent).nr
    ueber(parent).last = AnzahlUeberschriften
    ueber(parent).next = AnzahlUeberschriften + 1
    parent = ueber(parent).parent
    ebene -= 1
    continue do
  end if
  if zeile <> "" then headline = 0 : add zeile
loop
close #1
addZeile(1)
do while ebene > 0                     ' Fehler abfangen: falsche Ueberschriftsebene
  ueber(parent).last = AnzahlUeberschriften
  ueber(parent).next = AnzahlUeberschriften + 1
  parent = ueber(parent).parent
  ebene -= 1
loop
if setIndexDepth = 0 then setIndexDepth = 1

'*************************
' Anzeige der ReadMe-Datei

' Inhaltsverzeichnis (-i)
if OPT_index then
  for i as ubyte = 1 to AnzahlUeberschriften
    if ueber(i).ebene = 0 and i > 1 then print
    print space(ueber(i).ebene*2) & nummer(ueber(i)) & " " & ueber(i).text
  next
  print
end if

' reine Textausgabe (-t)
if OPT_text then
  for i as ubyte = 2 to AnzahlSeiten
    dim as ushort y = wort(i, 1).y
    for k as ushort = 1 to wortzahl(i)
      with wort(i, k)
        do while .y > y
          y += 16
          print
        loop
        print .text & " ";
      end with
    next
    print : print
  next
end if

if (OPT_index or OPT_text) and not OPT_format then end
' normale Anzeige
screen 18
width 80, 30

'Warnung bei falscher Programmversion
if WARNUNG = 1 then
  locate 2, 1
  print " ACHTUNG: Die im Dokument angegebene Programmversion (" & setVersion & ") entspricht"
  print " nicht der tatsaechlichen Version (" & _version & "). Unter Umstaenden kann es"
  print " vorkommen, dass Teile des Dokuments nicht korrekt angezeigt werden!"
  print : print : print " Druecken Sie eine Taste, um mit der Anzeige fortzufahren."
  getkey
end if
' Hilfe-Seite anlegen
merke = AnzahlSeiten
AnzahlSeiten = 0
laenge = 0 : AnzahlWoerter = 0 : AnzahlZeilen = 0
add " Die Bedienung des Programms laeuft ueber die Tastatur und/oder Maus. Um in das"
add " Inhaltsverzeichnis zu wechseln, druecken Sie die Taste 'i' oder die Pfeiltaste oben."
add " Mit den Pfeiltasten rechts und links koennen Sie im Dokument vor- und zurueck-"
add " blaettern. Die Taste 'h' ruft diese Hilfe auf. [newline] [newline]"
add " Sie koennen auch direkt zu einem Kapitel springen, indem Sie einfach die"
add " Kapitelnummer druecken. Ein Druck auf die Taste '3' z. B. springt direkt"
add " zu dem Kapitel mit der Ueberschrift-Nummer 3. Dies funktioniert natuerlich"
add " nur fuer die Ueberschrift-Nummern 1 bis 9. [newline] [newline]"
add " Groessere Spruenge innerhalb der Datei werden durch die Tasten 'Bild ab' und"
add " 'Bild auf' ermoeglicht. 'Bild ab' blaettert bis zu 10 Seiten weiter 'Bild auf'"
add " bis zu 10 Seiten zurueck. Mit 'Ende' kann direkt zur letzten Seite der Datei"
add " gesprungen werden. 'Pos1' springt zur Seite 1. [newline] [newline]"
add " Mit \[ESC] beenden Sie das Programm. [newline] [newline] [newline]"
add " Druecken Sie nun eine beliebige Taste, um fortzufahren."
addZeile(1)
' Index und evtl. Subindex erstellen
AnzahlSeiten = 1
laenge = 0 : AnzahlWoerter = 0 : AnzahlZeilen = 0
inhalt
if setSubIndex = 1 then
  i = 1
  do
    AnzahlSeiten = ueber(i).seite - 1
    laenge = 0 : AnzahlWoerter = 0 : AnzahlZeilen = 0
    if ueber(i).nr > 0 then inhalt ueber(i).nr
    i = ueber(i).next
  loop until i = 0
end if
AnzahlSeiten = merke

color setFarbe, setBackground
dim as ubyte aktuelleSeite = 1, gehezu
dim as string taste
do
  cls
  gehezu = 0
  schreibeSeite(aktuelleSeite)
  do
    getmouse mx, my,, mb
    sleep 1
  loop until mb < 1
  do
    sleep 1
    taste = inkey
    getmouse mx, my,, mb
    if mb = 1 then
      if my > 464 then
        if mx > 16  and mx < 96  then taste = chr(255, 75)
        if mx > 136 and mx < 216 then taste = "i"
        if mx > 256 and mx < 328 then taste = chr(255, 77)
        if mx > 376 and mx < 448 then taste = "h"
        if mx > 496 and mx < 576 then taste = chr(27)
      end if
      for i as ubyte = 6 to AnzahlLinks
        with link(i)
          if mx > .x and mx < .x2 and my > .y and my < .y + 16 then
            gehezu = .url
            exit do
          end if
        end with
      next
    end if
  loop until taste <> ""
  if gehezu > 0 and gehezu <= AnzahlSeiten then
    history(AnzahlHistory) = aktuelleSeite
    AnzahlHistory += 1
    aktuelleSeite = gehezu + 1
    continue do
  end if
  if val(taste) > 0 then
    if ueberschrift2seite(val(taste))>0 then aktuelleSeite=ueberschrift2seite(val(taste))
  end if
  select case taste
    case chr(8)
      if history(AnzahlHistory - 1) <> 0 then
        AnzahlHistory -= 1
        aktuelleSeite = history(AnzahlHistory)
        history(AnzahlHistory) = 0
      end if
    case chr(255, 77)  ' rechts
      if aktuelleSeite < AnzahlSeiten then aktuelleSeite += 1
    case chr(255, 75)  ' links
      if aktuelleSeite > 1 then aktuelleSeite -= 1
    case chr(255, 72), "i", "I"
      aktuelleSeite = 1
    case chr(255)+chr(71)  ' Pos1
      aktuelleSeite = 2
    case chr(255)+chr(79)  ' Ende
      aktuelleSeite = AnzahlSeiten
    case chr(255)+chr(81)  ' Bild ab
      aktuelleSeite = iif(aktuelleSeite<AnzahlSeiten-10, aktuelleSeite+10, AnzahlSeiten+0)
    case chr(255)+chr(73)  ' Bild auf
      aktuelleSeite = iif(aktuelleSeite>11, aktuelleSeite-10, 1)
    case "h", "H"
      schreibeSeite(0)
      getkey
  end select
loop until taste = chr(27) or taste = chr(255)+ "k"
end

sub add(byval text as string)
  ' fuegt einen Text zu einer Seite hinzu
  if AnzahlSeiten = 255 and AnzahlZeilen > 25 then exit sub
  dim as string naechstes
  neutext &= " " & text
  dim as ubyte i, k, position = 0, nlang, newline = 0
  do
    neutext = ltrim(neutext)
    position = instr(neutext, " ")
    if position = 0 then                            ' letztes Wort gefunden
      naechstes = neutext
    else
      naechstes = left(neutext, position-1)
    end if
    nlang = len(naechstes)
    if naechstes = "[newline]" then                 ' erzwungener Zeilenumbruch
      newline = 1
      nlang = 0
      neutext = mid(neutext, 10)
    end if
    if naechstes = "[b]"  then setFett = 1          ' Fettdruck ein
    if naechstes = "[/b]" then setFett = 0          ' Fettdruck aus
    if naechstes = "[u]"  then setUnterstrichen = 1 ' Unterstrich ein
    if naechstes = "[/u]" then setUnterstrichen = 0 ' Unterstrich aus
    if left(naechstes, 7) = "[color=" and right(naechstes, 1) = "]" then
      setFarbe = val(mid(naechstes, 8)) mod 16
    end if
    if naechstes = "[/color]" then                  ' Textfarbe zuruecksetzen
      setFarbe = setColor
    end if                                          ' Link starten
    if left(naechstes, 5) = "[url=" and right(naechstes, 1) = "]" then
      if naechstes[5] = asc("p") then
        setUrl = val(mid(naechstes, 7)) and 255
      elseif naechstes[5] = asc("h") then
        dim as ubyte punkt = instr(naechstes, ".")
        if punkt > 0 then
          setUrl = (val(mid(naechstes, 7, punkt-7)) and 255) * 256
          setUrl += (val(mid(naechstes, punkt+1)) and 255)
        else
          setUrl = (val(mid(naechstes, 7)) and 255) * 256
        end if
      end if
    end if
    if naechstes = "[/url]" then setUrl = 0         ' Link beenden
    if naechstes = "[center]" then                  ' zentrierte Zeile Anfang
      addZeile(1)
      AnzahlWoerter = 0
      AnzahlZeilen += 1
      laenge = 0
      setZentriert = 1
    end if
    if naechstes = "[/center]" then                 ' zentrierte Zeile Ende
      addZeile(1)
      AnzahlWoerter = 0
      AnzahlZeilen += 1
      laenge = 0
      setZentriert = 0
    end if                                          ' Tabulator
    if left(naechstes,4) = "[tab" and right(naechstes, 1) = "]" then
      tabulator(AnzahlWoerter+1) = val(mid(naechstes, 5))
      laenge = tabulator(AnzahlWoerter+1)\8
    end if                                          ' Tags (auch nicht existierende) entfernen
    if left(naechstes, 1) = "[" and right(naechstes, 1) = "]" and naechstes <> "[newline]" then
      neutext = mid(neutext, nlang+1)
      continue do
    end if
    if left(naechstes, 1) = "\" then                ' Escape-Sequenz entfernen
      nlang -= 1
      naechstes = mid(naechstes, 2)
      neutext = mid(neutext, 2)
    end if
    if nlang > 77 then                              ' zu lange Woerter kuerzen
      naechstes = left(naechstes, 77) & "~"
      neutext = left(neutext, 76) & "~" & mid(neutext, nlang+1)
      nlang = 77
    end if
    if naechstes = "" then continue do              ' leere Woerter nicht einfuegen
    if laenge+nlang < 78 and newline = 0 then       ' Wort passt noch in die Zeile
      AnzahlWoerter += 1
      wortliste(AnzahlWoerter) = naechstes
      attribut(AnzahlWoerter) = setFarbe
      url(AnzahlWoerter) = setUrl
      if setFett > 0 then attribut(AnzahlWoerter) += _fett
      if setUnterstrichen > 0 then attribut(AnzahlWoerter) += _unterstrichen
      neutext = mid(neutext, nlang+1)
      laenge += nlang+1
    else
      addZeile(newline)
      AnzahlWoerter = 0
      AnzahlZeilen += 1
      laenge = 0
      newline = 0
    end if
    if AnzahlWoerter > 39 then                      ' Fehler abfangen (z. B. bei TAB)
      addZeile(newline)
      AnzahlWoerter = 0
      AnzahlZeilen += 1
      laenge = 0
      newline = 0
    end if
    if AnzahlZeilen > 25 then
      if AnzahlSeiten = 255 then exit sub
      AnzahlSeiten += 1
      AnzahlZeilen = 0
    end if
  loop until position = 0
end sub

sub addZeile(byref newline as ubyte)
  'schreibt eine Zeile fertig
  dim leerbreite as single = 8, tempwort as TypWort
  dim as ushort xpos = 8, ypos = AnzahlZeilen*16 + 32
  dim as ubyte zentriert = setZentriert
  'suche nach Tabulatoren (-> keine Zentrierung, kein Blocksatz!)
  for i as ubyte = 1 to AnzahlWoerter
    if tabulator(i) > 0 then
      zentriert = 0
      newline = 1
      exit for
    end if
  next
  ' "kein Wort" in der Zeile (Fehlerbehebung bei Einzelwort vor Seitenumbruch)
  if AnzahlWoerter = 0 and trim(neutext) <> "" and left(trim(neutext), 1) <> "[" then
    AnzahlWoerter = 1
    wortliste(1) = left(neutext, 78)
    attribut(1) = setFarbe
    url(1) = setUrl
    if setFett > 0 then attribut(1) += _fett
    if setUnterstrichen > 0 then attribut(1) += _unterstrichen
    laenge += len(neutext)
    neutext = ""
  end if
  ' Startpunkt fuer zentrierten Text berechnen
  if zentriert > 0 then
    xpos = 320 - laenge*4
  else
    if newline = 0 and AnzahlWoerter > 1 then leerbreite += (78 - laenge + 1)*8 / (AnzahlWoerter - 1)
  end if
  for i as ubyte = 1 to AnzahlWoerter
    with tempwort
      ' Spezialformatierung fuer Links:
      .link = 0
      if url(i) > 0 then
        attribut(i) = (setLinkColor + (attribut(i) and &Hff00))
        .link = url(i)
        if setLinkUnderline then
          attribut(i) or= _unterstrichen
        else
          attribut(i) and= not(_unterstrichen)
        end if
      end if
      if tabulator(i) > 0 then
        .x = tabulator(i)
        xpos = .x - leerbreite*(i-1)
      else
        .x = xpos + leerbreite*(i-1)
      end if
      .y = ypos
      .attribut = attribut(i)
      .text = wortliste(i)
      xpos += len(.text)*8
    end with
    if wortzahl(AnzahlSeiten) > 499 then exit for
    wortzahl(AnzahlSeiten) += 1
    wort(AnzahlSeiten, wortzahl(AnzahlSeiten)) = tempwort
  next
  erase wortliste, attribut, tabulator, url
end sub

sub inhalt(byval nr as ubyte = 0)
  'Inhaltsverzeichnis erstellen
  dim as ubyte haupt = 0, zeilenzahl = 0, MaxRueck, punkt
  dim as string temp
  MaxRueck = iif(MaxEbene < setIndexDepth or nr > 0, Maxebene+0, setIndexDepth+0)
  dim as short einrueck = (39-MaxLang(nr)/2-MaxRueck)*8
  if nr = 0 then add "[tab248] [u] INHALTSVERZEICHNIS [u] [newline]"
  for i as ubyte = 1 to AnzahlUeberschriften
    if ueber(i).ebene = 0 then haupt += 1              ' Nr. der Hauptueberschrift
    if ueber(i).ebene >= setIndexDepth and nr = 0 then continue for
    if nr > 0 and haupt <> nr then continue for
    if ueber(i).ebene = 0 then
      add "[newline]"
      zeilenzahl += 1
    end if
    temp = nummer(ueber(i))
    punkt = instr(instr(temp, ".") + 1, temp, ".")     ' zweiten Punkt suchen
    if punkt > 0 then
      add "[url=h" & left(temp, punkt-1) & "]"
    else
      add "[url=h" & temp & "]"
    end if
    add "[tab" & einrueck+ueber(i).ebene*16 & "] " & left(temp & " " & ueber(i).text, 76)
    add "[/url] [newline]"
    zeilenzahl += 1
    if zeilenzahl > 24 - 2*(nr>0) then exit for
  next
  addZeile 1
end sub

function nummer(byval ueberschrift as TypUeberschrift) as string
  ' berechnet rekursiv die Nummerierung einer Ueberschrift
  dim as string ret = str(ueberschrift.nr)
  if ueberschrift.ebene > 0 then ret = nummer(ueber(ueberschrift.parent)) + "." + ret
  return ret
end function

sub schreibeSeite(byref seite as ubyte)
  cls
  dim vorwort as TypWort
  dim as ushort i, aktLink, aktLinkY
  dim as ubyte aktUeber
  erase link
  AnzahlLinks = 5
  ' zugehoerige Hauptueberschrift suchen
  for i = 1 to AnzahlUeberschriften
    if ueber(i).ebene = 0 and ueber(i).seite <= seite + setSubIndex then aktUeber = i
    if ueber(i).seite >= seite + setSubIndex then exit for
  next
  if aktUeber > 0 then draw string (8, 0), nummer(ueber(aktUeber)) & ") " & ueber(aktUeber).text, setMenuColor

  if seite = 0 then
    draw string (560, 0), "HILFE", setMenuColor
  elseif seite = 1 then
    draw string (560, 0), "INHALT", setMenuColor
  else
    draw string (560, 0), "SEITE " & seite-1, setMenuColor
  end if
  line (0, 17)-step(640, 0), setMenuColor
  for i = 1 to wortzahl(seite)
    with wort(seite, i)
      draw string (.x, .y), .text, .attribut and 15
      ' Attribute (unterstrichen, fett)
      if .attribut and _unterstrichen then
        vorwort = wort(seite, i-1)
        if vorwort.attribut and _unterstrichen and vorwort.y = .y then
          line (vorwort.x+len(vorwort.text)*8, .y+14)-(.x+len(.text)*8, .y+14), .attribut and 15
        else
          line (.x, .y+14)-(.x+len(.text)*8, .y+14), .attribut and 15
        end if
      end if
      if .attribut and _fett then draw string (.x+1, .y), .text, .attribut and 15
      ' Link
      if .link > 0 then
        if .link = aktLink and .y = aktLinkY then
          link(AnzahlLinks).x2 = .x + 8*len(.text)
        elseif AnzahlLinks < 50 then
          AnzahlLinks += 1
          link(AnzahlLinks).x = .x
          link(AnzahlLinks).y = .y
          link(AnzahlLinks).x2 = .x + 8*len(.text)
          if .link < 256 then
            link(AnzahlLinks).url = .link
          else
            link(AnzahlLinks).url = ueberschrift2seite(.link \ 256, .link mod 256) - 1
          end if
          aktLink = .link
          aktLinkY = .y
        end if
      else
        aktLink = 0
      end if
    end with
  next
  line (0, 460)-step(640, 0), setMenuColor
  if seite = 0 then exit sub
  if seite > 2 then draw string (16,  464), "<- zurueck", setMenuColor
  if seite > 1 then draw string (136, 464), "(i) Inhalt", setMenuColor
  if seite < AnzahlSeiten then draw string (256, 464), "-> weiter", setMenuColor
  draw string (376, 464), "(h) Hilfe", setMenuColor
  draw string (496, 464), "[ESC] Ende", setMenuColor
end sub

function ueberschrift2seite(byval nr as ubyte, byval nr2 as ubyte = 0) as ubyte
  ' gibt die Seite zurueck, auf der sich die Ueberschrift nr.nr2) befindet
  dim as ubyte k = 1
  'Hauptueberschrift suchen
  for i as ubyte = 1 to nr - 1
    k = ueber(k).next
    if k = 0 then return 0                    ' keine weitere Ueberschrift mehr vorhanden
  next
  ' evtl. Teilueberschrift suchen
  if nr2 > 0 and ueber(k).first > 0 then
    k = ueber(k).first
    for i as ubyte = 1 to nr2 - 1
      if ueber(ueber(k).next).ebene = 0 then  ' letzte Teilueberschrift vorbei
        return ueber(ueber(k).parent).seite
      end if
      k = ueber(k).next
    next
  end if
  if setSubIndex = 1 and nr2 = 0 then return ueber(k).seite - 1
  return ueber(k).seite
end function
